package edu.cmu.cs.fluid.Tallyho;

import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.*;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.core.resources.*;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class TallyhoPlugin extends AbstractUIPlugin {
  //The shared instance.
  private static TallyhoPlugin plugin;
  //Resource bundle.
  private ResourceBundle resourceBundle;

  /**
   * The constructor.
   */
  public TallyhoPlugin(IPluginDescriptor descriptor) {
    super(descriptor);
    plugin = this;
    try {
      resourceBundle =
        ResourceBundle.getBundle(
          "edu.cmu.cs.fluid.Tallyho.TallyhoPluginResources");
    } catch (MissingResourceException x) {
      resourceBundle = null;
    }
    org.apache.log4j.BasicConfigurator.configure();
    org.apache.log4j.Logger.getRootLogger().setLevel(
      org.apache.log4j.Level.DEBUG);
  }

  /**
   * Returns the shared instance.
   */
  public static TallyhoPlugin getDefault() {
    return plugin;
  }

  /**
   * Returns the workspace instance.
   */
  public static IWorkspace getWorkspace() {
    return ResourcesPlugin.getWorkspace();
  }

  /**
   * Returns the string from the plugin's resource bundle,
   * or 'key' if not found.
   */
  public static String getResourceString(String key) {
    ResourceBundle bundle = TallyhoPlugin.getDefault().getResourceBundle();
    try {
      return bundle.getString(key);
    } catch (MissingResourceException e) {
      return key;
    }
  }

  /**
   * Returns the plugin's resource bundle,
   */
  public ResourceBundle getResourceBundle() {
    return resourceBundle;
  }

  /**
   * Returns a image descriptor from the "icons/" directory within this plugin.
   */
  static public ImageDescriptor getImageDescriptor(String fileName) {
    String iconPath = "icons/";
    try {
      TallyhoPlugin plugin = TallyhoPlugin.getDefault();
      URL installURL = plugin.getDescriptor().getInstallURL();
      URL url = new URL(installURL, iconPath + fileName);
      return ImageDescriptor.createFromURL(url);
    } catch (MalformedURLException e) {
      // should not happen
      return ImageDescriptor.getMissingImageDescriptor();
    }
  }
}