package edu.cmu.cs.fluid.Tallyho.analysis.util;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.jdt.core.ICompilationUnit;

/**
 * Used to hold a marker which is used to direct the editor to a Java
 * file and line number location of "interest"
 */
public final class JavaEditorMarker {

  private ICompilationUnit javaFile;
  private int lineNumber = 0;
  private IMarker location = null;

  private JavaEditorMarker() {
  }

  public JavaEditorMarker(int lineNumber, ICompilationUnit javaFile) {
    try {
      location =
        ResourcesPlugin.getWorkspace().getRoot().createMarker(
          "edu.cmu.fluid.cs.QA");
      location.setAttribute(IMarker.LINE_NUMBER, lineNumber);
    } catch (org.eclipse.core.runtime.CoreException e) {
      //TODO
      System.out.println(
        "[JavaEditorMarker] CoreException received when getting IMarker");
    }
    this.javaFile = javaFile;
    this.lineNumber = lineNumber;
  }

  public ICompilationUnit getJavaFile() {
    return javaFile;
  }

  public int getLineNumber() {
    return lineNumber;
  }

  public String getPaddedLineNumber() {
    String sortPad = "0000000000";
    String lineNoString = "" + lineNumber;
    return sortPad.substring(lineNoString.length()) + lineNoString;
  }

  public IMarker getLocation() {
    return location;
  }
}